/*
 * =================================================================================
 * Copyright (C) 2013 Martin Albedinsky [Wolf-ITechnologies]
 * =================================================================================
 * Licensed under the Apache License, Version 2.0 or later (further "License" only);
 * ---------------------------------------------------------------------------------
 * You may use this file only in compliance with the License. More details and copy
 * of this License you may obtain at
 * 
 * 		http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You can redistribute, modify or publish any part of the code written in this
 * file but as it is described in the License, the software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES or CONDITIONS OF
 * ANY KIND.
 * 
 * See the License for the specific language governing permissions and limitations
 * under the License.
 * =================================================================================
 */
package com.wit.and.database.manage;

/**
 * <h4>Class Overview</h4>
 * <p>
 * </p>
 *
 * @author Martin Albedinsky
 */
public class EntitySelection {

	/**
	 * Constants =============================
	 */

	/**
	 * Log TAG.
	 */
	private static final String TAG = EntitySelection.class.getSimpleName();

	/**
	 * Indicates if debug private output trough log-cat is enabled.
	 */
	// private static final boolean DEBUG = false;

	/**
	 * Indicates if logging for user output trough log-cat is enabled.
	 */
	// private static final boolean USER_LOG = true;

	/**
	 * Enums =================================
	 */

	/**
	 * Static members ========================
	 */

	/**
	 * Members ===============================
	 */

	/**
	 * Listeners -----------------------------
	 */

	/**
	 * Arrays --------------------------------
	 */

	/**
	 * Booleans ------------------------------
	 */

	/**
	 * Constructors ==========================
	 */

	/**
	 * Methods ===============================
	 */

	/**
	 * Public --------------------------------
	 */

	/**
	 * Getters + Setters ---------------------
	 */

	/**
	 * Protected -----------------------------
	 */

	/**
	 * Private -------------------------------
	 */

	/**
	 * Abstract methods ----------------------
	 */

	/**
	 * Inner classes =========================
	 */

	/**
	 * <h4>Class Overview</h4>
	 * <p>
	 * </p>
	 *
	 * @author Martin Albedinsky
	 */
	public static class SelectionArguments {

		/**
		 * Enums =================================
		 */

		/**
		 *
		 */
		private enum ArgsType {
			INT, LONG, DOUBLE
		}

		/**
		 * Members ===============================
		 */

		/**
		 *
		 */
		private String mSelection, mUpdatedSelection;

		/**
		 * Arrays --------------------------------
		 */

		/**
		 * Constructors ==========================
		 */

		/**
		 * <p>
		 * </p>
		 *
		 * @param tableName
		 * @param columnName
		 */
		public SelectionArguments(String tableName, String columnName) {
			this(tableName + "." + columnName);
		}

		/**
		 * <p>
		 * </p>
		 *
		 * @param tableSelection
		 */
		public SelectionArguments(String tableSelection) {
			this.mSelection = tableSelection;
		}

		/**
		 * Methods ===============================
		 */

		/**
		 * Public --------------------------------
		 */

		/**
		 * <p>
		 * </p>
		 *
		 * @param args
		 * @return
		 *
		 * @see #createSingleArgs(Long[])
		 * @see #createSingleArgs(Double[])
		 */
		public String[] createSingleArgs(Integer[] args) {
			return this.createSingleArgsInner(args, ArgsType.INT);
		}

		/**
		 * <p>
		 * </p>
		 *
		 * @param args
		 * @return
		 *
		 * @see #createSingleArgs(Integer[])
		 * @see #createSingleArgs(Double[])
		 */
		public String[] createSingleArgs(Long[] args) {
			return this.createSingleArgsInner(args, ArgsType.LONG);
		}

		/**
		 * <p>
		 * </p>
		 *
		 * @param args
		 * @return
		 *
		 * @see #createSingleArgs(Integer[])
		 * @see #createSingleArgs(Long[])
		 */
		public String[] createSingleArgs(Double[] args) {
			return this.createSingleArgsInner(args, ArgsType.DOUBLE);
		}

		/**
		 * Getters + Setters ---------------------
		 */

		/**
		 * <p>
		 * </p>
		 *
		 * @return
		 */
		public String getSelection() {
			return  mSelection;
		}

		/**
		 * <p>
		 * </p>
		 *
		 * @return
		 */
		public String getUpdatedSelection() {
			return mUpdatedSelection;
		}

		/**
		 * Private -------------------------------
		 */

		/**
		 *
		 * @param args
		 * @param type
		 * @return
		 */
		private String[] createSingleArgsInner(Object[] args, ArgsType type) {
			String[] selectionArgs = new String[args.length];
			final int penultimate = selectionArgs.length - 1;
			StringBuilder builder = new StringBuilder("");

			for (int i = 0; i < selectionArgs.length; i++) {
				String converted = "";
				switch (type) {
					case INT:
						converted = Integer.toString((Integer) args[i]);
						break;
					case LONG:
						converted = Long.toString((Long) args[i]);
						break;
					case DOUBLE:
						converted = Double.toString((Double) args[i]);
						break;
				}
				// Update selection arguments.
				selectionArgs[i] = converted;

				// Update selection.
				builder.append(mSelection);
				builder.append("=?");

				if (i < penultimate) {
					// Append OR.
					builder.append(" OR ");
				}
			}

			// Modify selection.
			this.mUpdatedSelection = builder.toString();
			return selectionArgs;
		}
	}

	/**
	 * Interface =============================
	 */
}
