/*
 * =================================================================================
 * Copyright (C) 2013 Martin Albedinsky [Wolf-ITechnologies]
 * =================================================================================
 * Licensed under the Apache License, Version 2.0 or later (further "License" only);
 * ---------------------------------------------------------------------------------
 * You may use this file only in compliance with the License. More details and copy
 * of this License you may obtain at
 * 
 * 		http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You can redistribute, modify or publish any part of the code written in this
 * file but as it is described in the License, the software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES or CONDITIONS OF
 * ANY KIND.
 * 
 * See the License for the specific language governing permissions and limitations
 * under the License.
 * =================================================================================
 */
package com.wit.and.database.manage;

/**
 * <h4>Class Overview</h4>
 * <p>
 * </p>
 *
 * @author Martin Albedinsky
 */
public class LoaderOptions {

	/**
	 * Constants =============================
	 */

	/**
	 * Log TAG.
	 */
	private static final String TAG = LoaderOptions.class.getSimpleName();

	/**
	 * Indicates if debug private output trough log-cat is enabled.
	 */
	// private static final boolean DEBUG = false;

	/**
	 * Indicates if logging for user output trough log-cat is enabled.
	 */
	// private static final boolean USER_LOG = true;

	/**
	 * Enums =================================
	 */

	/**
	 * Static members ========================
	 */

	/**
	 * Members ===============================
	 */

	/**
	 *
	 */
	private String mSelection;

	/**
	 *
	 */
	private String mSort;

	/**
	 * Listeners -----------------------------
	 */

	/**
	 * Arrays --------------------------------
	 */

	/**
	 *
	 */
	private String[] aProjection;

	/**
	 *
	 */
	private String[] aSelectionArgs;

	/**
	 * Booleans ------------------------------
	 */

	/**
	 * Constructors ==========================
	 */

	/**
	 * <p>
	 * </p>
	 */
	public LoaderOptions() {
		// TODO: get projection, sort, selection? from annotations.
	}

	/**
	 * Methods ===============================
	 */

	/**
	 * Public --------------------------------
	 */

	/**
	 * <p>
	 * </p>
	 *
	 * @return
	 */
	public boolean isValid() {
		// TODO: check
		return true;
	}

	/**
	 * Getters + Setters ---------------------
	 */

	/**
	 * <p>
	 * </p>
	 *
	 * @param projection
	 * @return This options.
	 */
	public LoaderOptions projection(String[] projection) {
		this.aProjection = projection;
		return this;
	}

	/**
	 * <p>
	 * </p>
	 *
	 * @param projection
	 * @return
	 */
	public LoaderOptions projection(EntityProjection projection) {
		this.aProjection = projection.create();
		return this;
	}

	/**
	 * <p>
	 * </p>
	 *
	 * @return
	 */
	public String[] getProjection() {
		return aProjection;
	}

	/**
	 * <p>
	 * </p>
	 *
	 * @param selection
	 * @return This options.
	 */
	public LoaderOptions selection(String selection) {
		this.mSelection = selection;
		return this;
	}

	/**
	 * <p>
	 * </p>
	 *
	 * @return
	 */
	public String getSelection() {
		return mSelection;
	}

	/**
	 * <p>
	 * </p>
	 *
	 * @param arguments
	 * @return This options.
	 */
	public LoaderOptions selectionArgs(String[] arguments) {
		this.aSelectionArgs = arguments;
		return this;
	}

	/**
	 * <p>
	 * </p>
	 *
	 * @return
	 */
	public String[] getSelectionArgs() {
		return aSelectionArgs;
	}

	/**
	 * <p>
	 * </p>
	 *
	 * @param sortOrder
	 * @return This options.
	 */
	public LoaderOptions sort(String sortOrder) {
		this.mSort = sortOrder;
		return this;
	}

	/**
	 * <p>
	 * </p>
	 *
	 * @return
	 */
	public String getSort() {
		return mSort;
	}

	/**
	 * Protected -----------------------------
	 */

	/**
	 * Private -------------------------------
	 */

	/**
	 * Abstract methods ----------------------
	 */

	/**
	 * Inner classes =========================
	 */

	/**
	 * Interface =============================
	 */
}
