/*
 * =================================================================================
 * Copyright (C) 2013 Martin Albedinsky [Wolf-ITechnologies]
 * =================================================================================
 * Licensed under the Apache License, Version 2.0 or later (further "License" only);
 * ---------------------------------------------------------------------------------
 * You may use this file only in compliance with the License. More details and copy
 * of this License you may obtain at
 * 
 * 		http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You can redistribute, modify or publish any part of the code written in this
 * file but as it is described in the License, the software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES or CONDITIONS OF
 * ANY KIND.
 * 
 * See the License for the specific language governing permissions and limitations
 * under the License.
 * =================================================================================
 */
package com.wit.and.examples.database;

import com.wit.and.database.BaseDatabaseProvider;
import com.wit.and.database.annotations.DatabaseAuthority;
import com.wit.and.database.annotations.DatabaseEntities;
import com.wit.and.database.annotations.DatabaseName;
import com.wit.and.database.annotations.DatabaseVersion;
import com.wit.and.examples.database.entity.EntityCustomers;
import com.wit.and.examples.database.entity.EntityGoods;

/**
 * @author Martin Albedinsky
 */
@DatabaseName("examples.db")
@DatabaseVersion(1)
@DatabaseAuthority(DatabaseProvider.DATABASE_AUTHORITY)
@DatabaseEntities({EntityCustomers.class, EntityGoods.class})
public class DatabaseProvider extends BaseDatabaseProvider {

	public static final String DATABASE_AUTHORITY = "com.wit.and.examples.database.DatabaseProvider";
}
