/*
 * =================================================================================
 * Copyright (C) 2013 Martin Albedinsky [Wolf-ITechnologies]
 * =================================================================================
 * Licensed under the Apache License, Version 2.0 or later (further "License" only);
 * ---------------------------------------------------------------------------------
 * You may use this file only in compliance with the License. More details and copy
 * of this License you may obtain at
 * 
 * 		http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You can redistribute, modify or publish any part of the code written in this
 * file but as it is described in the License, the software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES or CONDITIONS OF
 * ANY KIND.
 * 
 * See the License for the specific language governing permissions and limitations
 * under the License.
 * =================================================================================
 */
package com.wit.and.examples.database.entity;

import com.wit.and.database.annotations.async.AsyncTransaction;
import com.wit.and.examples.database.model.Customer;

/**
 * Interface for customers entity transactions handling.
 */
public interface EntityCustomersTransactions {

	/**
	 * Creates asynchronously new customer.
	 *
	 * @param customer Customer to create.
	 */
	@AsyncTransaction
	public void createCustomer(Customer customer);
}
