/*
 * =================================================================================
 * Copyright (C) 2013 Martin Albedinsky [Wolf-ITechnologies]
 * =================================================================================
 * Licensed under the Apache License, Version 2.0 or later (further "License" only);
 * ---------------------------------------------------------------------------------
 * You may use this file only in compliance with the License. More details and copy
 * of this License you may obtain at
 * 
 * 		http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You can redistribute, modify or publish any part of the code written in this
 * file but as it is described in the License, the software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES or CONDITIONS OF
 * ANY KIND.
 * 
 * See the License for the specific language governing permissions and limitations
 * under the License.
 * =================================================================================
 */
package com.wit.and.examples.database.model;

import com.wit.and.database.annotations.entity.EntityName;
import com.wit.and.database.annotations.manage.ContentValue;
import com.wit.and.database.entity.DatabaseEntityModel;
import com.wit.and.examples.database.entity.EntityCustomers;

/**
 * @author Martin Albedinsky
 */
@EntityName(EntityCustomers.ENTITY_NAME)
public class Customer extends DatabaseEntityModel {

	@ContentValue(EntityCustomers.COLUMN_FIRST_NAME)
	private String mFirstName;

	@ContentValue(EntityCustomers.COLUMN_LAST_NAME)
	private String mLastName;

	public Customer(String firstName, String lastName) {
		this.mFirstName = firstName;
		this.mLastName = lastName;
	}
}
